# For Developers

## Integration with dApps

To detect if users are accessing your dApp on Fina, you can check if the following object exist.

```typescript
window.fina
```

If this is `undefined` that means user is not accessing your dApp via Fina Wallet's in-app browser.

Fina Wallet exposes the same API as [Keplr](https://www.keplr.app/). So if your dApp supports Keplr, it should be working on Fina Wallet out of the box. You can check Keplr's API documentation [here](https://docs.keplr.app/api/)

Besides, the `window.fina` object is just a pointer to `window.keplr` so the underlying methods and properties will be the same

## Deep Linking

If you want to redirect users from your dApp to Fina Wallet, you can use the following deep link

```
fina://wallet
```

If you want to redirect users to your dApp directly on Fina's in-app browser, you can use the following deep link

```
fina://wallet/dapps?network=secret-4&url=https%3A%2F%2Fcard.fina.cash
```

There are 2 url parameters in the deep link

1. `network` - the chain ID of the network your dApp is connecting to
2. `url` - your dApp's URL-encoded url

Example (provided by SCRT Labs [here](https://github.com/scrtlabs/secret.js#fina-wallet))

```typescript
const urlSearchParams = new URLSearchParams();
urlSearchParams.append("network", "secret-4");
urlSearchParams.append("url", window.location.href);

window.open(`fina://wllet/dapps?${urlSearchParams.toString()}`, "_blank");
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fina.cash/fina-wallet/for-developers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
